#include <stdio.h>
#include <Windows.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 

//define for VerySetFunction
#define Very_Set_Range					131
#define Very_Get_PdfPageCount			206
#define Very_Get_PageBoxForStamp		260
#define Very_Set_Text_Leading			134
#define Very_Set_Opacity				240
#define Very_Set_EmbedFont				241
#define Very_Get_EmbedFont				241
#define Very_Set_TransparentColor		242
		
typedef long	(__stdcall *VeryStampRegFunc)(char *reg);
typedef long	(__stdcall *VeryStampLayerOpenFunc)(char *In, char *Out, char *lpFGLayerName,char *lpBGLayerName);
typedef long	(__stdcall *VeryStampOpenFunc)(char *In,char *Out);
typedef void	(__stdcall *VeryStampCloseFunc)(long id);
typedef long	(__stdcall *VeryStampSetFunctionFunc)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *VeryStampGetFunctionFunc)(long id,long func_code,long para1,long para2,char *para3,char *para4);
typedef long	(__stdcall *VeryStampAddImageFunc)(long id,long position, 
												   char *filename,
												   long shift_lr,long shift_tb,long rotate,long layer,
												   long zoomW,long zoomH,
												   long action,char *link,long pageno);
typedef long	(__stdcall *VeryStampAddImageExFunc)(long id,long position, char *filename,
													 long shift_lr,long shift_tb,long rotate,long layer,
													 long width,long height,
													 long action,char *link,long pageno);
typedef long	(__stdcall *VeryStampAddTextFunc)(long id,long position, 
												  char *string, long color,long alignment,
												  long shift_lr,long shift_tb,long rotate,long layer,
												  long hollow, long fontcode,char *fontname,long fontsize,
												  long action,char *link,long pageno);

typedef long	(__stdcall *VeryStampAddLineFunc)(long id,long position, long width,long color,
												  long shift_lr,long shift_tb,long rotate,long layer,
												  long zoomW,long zoomH);
typedef long	(__stdcall *VeryStampAddRectFunc)(long id,long sx_,long sy_,long ex_,long ey_,
												  long side_width,long side_color,
												  long flagFill,long fill_color);
typedef long	(__stdcall *VeryStampAddCircleFunc)(long id,long x,long y, long radius,
													long side_width,long side_color,
													long flagFill,long fill_color);
typedef long	(__stdcall *VeryStampAddEllipseFunc)(long id,long sx_,long sy_,long ex_,long ey_,
													 long side_width,long side_color,
													 long flagFill,long fill_color);
typedef long	(__stdcall *VeryStampAddCurveToFunc)(long id,long sx_,long sy_,long x1,long y1,
													 long x2,long y2,long x3,long y3,
													 long side_width,long side_color);

typedef long	(__stdcall *VeryStampAddRectWithLayerFunc)(long id,long sx_,long sy_,long ex_,long ey_,
														   long side_width,long side_color,
														   long flagFill,long fill_color,long layer);
typedef long	(__stdcall *VeryStampUndoFunc)(char *filename);
typedef long	(__stdcall *VeryStampAddLineExFunc)(long id,long sx,long sy,long ex,long ey,long width,long color);
typedef long	(__stdcall *VeryStampIsStampedFunc)(char *lpPDFFile);

typedef long (__stdcall *VeryStampForm_AllocFunc)();
typedef long (__stdcall *VeryStampForm_FreeFunc)(long id);
typedef long (__stdcall *VeryStampForm_SetTextFieldFunc)(long id, LPCTSTR lpFieldName, LPCTSTR lpFieldValue);
typedef long (__stdcall *VeryStampForm_SetCheckBoxFunc)(long id, LPCTSTR lpFieldName, LPCTSTR lpFieldValue);
typedef long (__stdcall *VeryStampForm_ApplyFunc)(long id, LPCTSTR lpInFile, LPCTSTR lpOutFile, LONG bFlatten);
typedef long (__stdcall *VeryStampForm_ClearFieldsFunc)(long id);

typedef long (__stdcall *VeryStampEncryptPDFFunc)(LPSTR lpInPDF, LPSTR lpOutPDF,char *lpszOpenPwd,char *lpszOwnerPwd,
							int iKeyLen, int iRestriction);
typedef BOOL (__stdcall *VeryStampDeleteStampFromPagesFunc)(char *lpInPDF, char *lpOutPDF, char *lpPageRange);
typedef long (__stdcall *VeryStampDeleteImagesFromPagesFunc)(char *lpInPDF, char *lpOutPDF, int nWidth, int nHeight, char *lpPageRange);
typedef int  (__stdcall *VeryStampSetLayerPrintFlagFunc)(long id, LPCTSTR lpLayerName, int nFlag);

HMODULE							g_hVeryW=NULL;

VeryStampRegFunc				VeryStampReg			= NULL;
VeryStampOpenFunc				VeryStampOpen			= NULL;
VeryStampLayerOpenFunc			VeryStampLayerOpen		= NULL;
VeryStampCloseFunc				VeryStampClose			= NULL;
VeryStampSetFunctionFunc		VeryStampSetFunction	= NULL;
VeryStampSetFunctionFunc		VeryStampGetFunction	= NULL;
VeryStampAddImageFunc			VeryStampAddImage		= NULL;
VeryStampAddImageExFunc			VeryStampAddImageEx		= NULL;
VeryStampAddTextFunc			VeryStampAddText		= NULL;
VeryStampAddLineFunc			VeryStampAddLine		= NULL;
VeryStampAddRectFunc			VeryStampAddRect		= NULL;
VeryStampAddRectWithLayerFunc	VeryStampAddRectWithLayer = NULL;
VeryStampUndoFunc				VeryStampUndo			= NULL;
VeryStampIsStampedFunc			VeryStampIsStamped		= NULL;
VeryStampAddLineExFunc			VeryStampAddLineEx		= NULL;
VeryStampAddCircleFunc			VeryStampAddCircle		= NULL;
VeryStampAddEllipseFunc			VeryStampAddEllipse		= NULL;
VeryStampAddCurveToFunc			VeryStampAddCurveTo		= NULL;

VeryStampForm_AllocFunc			VeryStampForm_Alloc			= NULL;
VeryStampForm_FreeFunc			VeryStampForm_Free			= NULL;
VeryStampForm_SetTextFieldFunc	VeryStampForm_SetTextField	= NULL;
VeryStampForm_SetCheckBoxFunc	VeryStampForm_SetCheckBox	= NULL;
VeryStampForm_ApplyFunc			VeryStampForm_Apply			= NULL;
VeryStampForm_ClearFieldsFunc	VeryStampForm_ClearFields	= NULL;

VeryStampEncryptPDFFunc			VeryStampEncryptPDF			= NULL;
VeryStampDeleteStampFromPagesFunc	VeryStampDeleteStampFromPages = NULL;
VeryStampDeleteImagesFromPagesFunc	VeryStampDeleteImagesFromPages = NULL;
VeryStampSetLayerPrintFlagFunc		VeryStampSetLayerPrintFlag = NULL;

typedef struct DLLFUNCtag{
	char *name1;
	char *name2;
	void **func;
}DLLFunc;
DLLFunc aryDLLFunc[] = {
	{"veryReg", "VeryStampReg", (void**)&VeryStampReg},
	{"veryOpen", "VeryStampOpen", (void**)&VeryStampOpen},
	{"veryClose", "VeryStampClose", (void**)&VeryStampClose},
	{"veryAddText", "VeryStampAddText", (void**)&VeryStampAddText},
	{"veryAddImage", "VeryStampAddImage", (void**)&VeryStampAddImage},
	{"veryAddImageEx", "VeryStampAddImageEx", (void**)&VeryStampAddImageEx},
	{"veryAddLine", "VeryStampAddLine", (void**)&VeryStampAddLine},
	{"veryAddLineEx", "VeryStampAddLineEx", (void**)&VeryStampAddLineEx},
	{"veryAddRect", "VeryStampAddRect", (void**)&VeryStampAddRect},
	{"verySetFunction", "VeryStampSetFunction", (void**)&VeryStampSetFunction},
	{"veryGetFunction", "VeryStampGetFunction", (void**)&VeryStampGetFunction},
	{"veryUndo", "VeryStampUndo", (void**)&VeryStampUndo},
	{"veryAddRectWithLayer", "VeryStampAddRectWithLayer", (void**)&VeryStampAddRectWithLayer},
	{"veryAddCircle", "VeryStampAddCircle", (void**)&VeryStampAddCircle},
	{"veryAddEllipse", "VeryStampAddEllipse", (void**)&VeryStampAddEllipse},
	{"veryAddCurveTo", "VeryStampAddCurveTo", (void**)&VeryStampAddCurveTo},
	{"VeryStampLayerOpen", "VeryStampLayerOpen", (void**)&VeryStampLayerOpen},
	{"veryIsStamped", "VeryStampIsStamped", (void**)&VeryStampIsStamped},
	{"VeryStampForm_Alloc", "VeryStampForm_Alloc", (void**)&VeryStampForm_Alloc},
	{"VeryStampForm_Free", "VeryStampForm_Free", (void**)&VeryStampForm_Free},
	{"VeryStampForm_SetTextField", "VeryStampForm_SetTextField", (void**)&VeryStampForm_SetTextField},
	{"VeryStampForm_SetCheckBox", "VeryStampForm_SetCheckBox", (void**)&VeryStampForm_SetCheckBox},
	{"VeryStampForm_Apply", "VeryStampForm_Apply", (void**)&VeryStampForm_Apply},
	{"VeryStampForm_ClearFields", "VeryStampForm_ClearFields", (void**)&VeryStampForm_ClearFields},
	{"VeryStampEncryptPDF", "VeryStampEncryptPDF", (void**)&VeryStampEncryptPDF},
	{"VeryStampDeleteStampFromPages", "VeryStampDeleteStampFromPages", (void**)&VeryStampDeleteStampFromPages},
	{"VeryStampDeleteImagesFromPages", "VeryStampDeleteImagesFromPages", (void**)&VeryStampDeleteImagesFromPages},
	{"VeryStampSetLayerPrintFlag", "VeryStampSetLayerPrintFlag", (void**)&VeryStampSetLayerPrintFlag},
};

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadVeryWDll(void);
void	FreeVeryWDll();

void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

BOOL LoadVeryWDll()
{
	int i;
	char path[_MAX_PATH];
	GetModulePath(path,"PdfStamp.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
	{
		GetModulePath(path,"verywrite.dll");
		g_hVeryW=LoadLibrary(path);
		if(g_hVeryW==NULL)
			goto Failer;
	}

	for(i = 0; i < sizeof(aryDLLFunc)/sizeof(DLLFunc); i++)
	{
		void *lpFunc = (void*)GetProcAddress(g_hVeryW,aryDLLFunc[i].name1);
		if(lpFunc == NULL)
			lpFunc = (void*)GetProcAddress(g_hVeryW,aryDLLFunc[i].name2);
		if(lpFunc)
			*aryDLLFunc[i].func = lpFunc;
		else
			goto Failer;
	}

	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;
}

void FreeVeryWDll()
{
	if(g_hVeryW==NULL)
		return ;
	FreeLibrary(g_hVeryW);
	g_hVeryW=NULL;
}

void main(int argc,char* argv[])
{
	char szPDFFile[256];
	char szOutFile[256];
	long id;
	int iRet = 0;

	memset(szPDFFile,0,256);
	memset(szOutFile,0,256);

	if(!LoadVeryWDll())
		return;

	//Register PDFStamp SDK with your License Key
	VeryStampReg("XXXXXXXXXXXXXXXXXXXXXXXX");

	GetModulePath(szPDFFile,"example.pdf");
	GetModulePath(szOutFile,"newlayer_printflag.pdf");
	
	id=VeryStampLayerOpen(szPDFFile,szOutFile, "Foreground_LayerName", "Background_LayerName");
	if(id>0){
		VeryStampSetLayerPrintFlag(id, "Foreground_LayerName", 0);
		VeryStampSetLayerPrintFlag(id, "Background_LayerName", 1);
		VeryStampAddText(	id, 2, 
						"VeryPDF Layer Stamper",
						2666666,17,
						0,200,0,0,
						0,
						0,0,32,
						0,0,0);
		VeryStampAddRect(id, 100, 100, 150,150, 2, RGB(255,0,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 300, 150,350, 2, RGB(255,0,0),1,RGB(255,0,0));
		VeryStampAddRect(id, 100, 400, 150,450, 4, RGB(255,255,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 500, 150,550, 4, RGB(255,255,0),1,RGB(255,0,255));

		VeryStampClose(id);
	}

	FreeVeryWDll();
}
